/*
 * Copyright 1997 Vectaport Inc.
 *
 * Permission to use, copy, modify, distribute, and sell this software and
 * its documentation for any purpose is hereby granted without fee, provided
 * that the above copyright notice appear in all copies and that both that
 * copyright notice and this permission notice appear in supporting
 * documentation, and that the names of the copyright holders not be used in
 * advertising or publicity pertaining to distribution of the software
 * without specific, written prior permission.  The copyright holders make
 * no representations about the suitability of this software for any purpose.
 * It is provided "as is" without express or implied warranty.
 *
 * THE COPYRIGHT HOLDERS DISCLAIM ALL WARRANTIES WITH REGARD TO THIS
 * SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS.
 * IN NO EVENT SHALL THE COPYRIGHT HOLDERS BE LIABLE FOR ANY SPECIAL,
 * INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING
 * FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT,
 * NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION
 * WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 * 
 */

#include <DemUnidraw/demclasses.h>
#include <DemUnidraw/demcomps.h>
#include <DemUnidraw/demcreator.h>

DemCreator::DemCreator() : MapCreator() {}

void* DemCreator::Create (ClassId id) {
  if (id == SURFACE_VIEW)    return new SurfaceView();
  if (id == SURFACE_SCRIPT)  return new SurfaceScript();
  if (id == DEMIDRAW_VIEW)    return new DemIdrawView();
  if (id == DEMIDRAW_SCRIPT)  return new DemIdrawScript();
  if (id == ROADS_VIEW)    return new RoadsView();
  if (id == ROADS_SCRIPT)  return new RoadsScript();
  if (id == ACTOR_VIEW) return new ActorView();

  return MapCreator::Create(id);
}
