/*
 * Copyright 1995 Vectaport Inc.
 *
 * Permission to use, copy, modify, distribute, and sell this software and
 * its documentation for any purpose is hereby granted without fee, provided
 * that the above copyright notice appear in all copies and that both that
 * copyright notice and this permission notice appear in supporting
 * documentation, and that the names of the copyright holders not be used in
 * advertising or publicity pertaining to distribution of the software
 * without specific, written prior permission.  The copyright holders make
 * no representations about the suitability of this software for any purpose.
 * It is provided "as is" without express or implied warranty.
 *
 * THE COPYRIGHT HOLDERS DISCLAIM ALL WARRANTIES WITH REGARD TO THIS
 * SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS.
 * IN NO EVENT SHALL THE COPYRIGHT HOLDERS BE LIABLE FOR ANY SPECIAL,
 * INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING
 * FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT,
 * NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION
 * WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 * 
 */

#ifndef dlgscripts_h
#define dlgscripts_h

#include <MapUnidraw/mapscripts.h>

class DlgFClassComp;
class DlgCovComp;
class DlgDbComp;
class DlgIdrawComp;
class DlgLibComp;

class DlgFClassScript : public MapFClassScript {
public:
    virtual ClassId GetClassId();
    virtual boolean IsA(ClassId);
    DlgFClassScript(DlgFClassComp* = nil);
    virtual boolean Definition(ostream&);

    static int ReadName(istream& in, void* addr1, void* addr2, void* addr3, void* addr4);
};

class DlgCovScript : public MapCovScript {
public:
    virtual ClassId GetClassId();
    virtual boolean IsA(ClassId);
    DlgCovScript(DlgCovComp* = nil);

    static int ReadName(istream& in, void* addr1, void* addr2, void* addr3, void* addr4);
    static int ReadChildren(istream&, void*, void*, void*, void*);
};

class DlgLibScript : public MapLibScript {
public:
    virtual ClassId GetClassId();
    virtual boolean IsA(ClassId);
    DlgLibScript(DlgLibComp* = nil);

    static int ReadName(istream& in, void* addr1, void* addr2, void* addr3, void* addr4);
    static int ReadChildren(istream&, void*, void*, void*, void*);
};

class DlgDbScript : public MapDbScript {
public:
    virtual ClassId GetClassId();
    virtual boolean IsA(ClassId);
    DlgDbScript(DlgDbComp* = nil);

    static int ReadPath(istream& in, void* addr1, void* addr2, void* addr3, void* addr4);
    static int ReadChildren(istream&, void*, void*, void*, void*);
};

class DlgIdrawScript : public MapIdrawScript {
public:
    virtual ClassId GetClassId();
    virtual boolean IsA(ClassId);
    DlgIdrawScript(DlgIdrawComp* = nil);

    virtual boolean Emit(ostream&);
    static int ReadChildren(istream&, void*, void*, void*, void*);
};

#endif
