/*
 * Copyright 1997 Vectaport Inc.
 * Copyright 1994, 1995 Vectaport Inc., Cartoactive Systems
 *
 * Permission to use, copy, modify, distribute, and sell this software and
 * its documentation for any purpose is hereby granted without fee, provided
 * that the above copyright notice appear in all copies and that both that
 * copyright notice and this permission notice appear in supporting
 * documentation, and that the names of the copyright holders not be used in
 * advertising or publicity pertaining to distribution of the software
 * without specific, written prior permission.  The copyright holders make
 * no representations about the suitability of this software for any purpose.
 * It is provided "as is" without express or implied warranty.
 *
 * THE COPYRIGHT HOLDERS DISCLAIM ALL WARRANTIES WITH REGARD TO THIS
 * SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS.
 * IN NO EVENT SHALL THE COPYRIGHT HOLDERS BE LIABLE FOR ANY SPECIAL,
 * INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING
 * FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT,
 * NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION
 * WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 * 
 */

#ifndef mapinspect_h
#define mapinspect_h

#include <Unidraw/Tools/tool.h>

class GraphicView;
class MapFClassView;
class OverlaysView;
class Selection;
class MapEditor;
class MapSelectionVar;
class MapSelectionState;

class MapInspectTool : public Tool {
public:
    MapInspectTool(MapSelectionState*,ControlInfo* = nil);

    virtual Manipulator* CreateManipulator(Viewer*, Event&, Transformer* =nil);
    virtual Command* InterpretManipulator(Manipulator*);

    virtual Tool* Copy();
    virtual ClassId GetClassId();
    virtual boolean IsA(ClassId);
protected:
    virtual void Localize(Selection*, Viewer*);
    virtual void DoInspect(GraphicView*, Viewer*);
    GraphicView* FindFeature(OverlaysView*, Event&, Selection*);
    GraphicView* FindInList(OverlaysView*, Event&);
    GraphicView* FindInFCView(MapFClassView*, Event&);
    MapSelectionState* selstate;
};

class MapSelectTool : public Tool {
public:
  MapSelectTool(ControlInfo* =nil);

  virtual Manipulator* CreateManipulator(Viewer*, Event&, Transformer* =nil);
  virtual Command* InterpretManipulator(Manipulator*);

  virtual Tool* Copy();
  virtual ClassId GetClassId();
  virtual boolean IsA(ClassId);
protected:
  void SelectFeatures(Selection*, GraphicView* views, Coord l,
			       Coord b, Coord r, Coord t);
  Selection* SelectMapFeatures(GraphicView* views, Coord l,
			       Coord b, Coord r, Coord t);
  void Localize(Selection*, Viewer*);
};

#endif
