/*
 * Copyright 1995-1997 Vectaport Inc.
 *
 * Permission to use, copy, modify, distribute, and sell this software and
 * its documentation for any purpose is hereby granted without fee, provided
 * that the above copyright notice appear in all copies and that both that
 * copyright notice and this permission notice appear in supporting
 * documentation, and that the names of the copyright holders not be used in
 * advertising or publicity pertaining to distribution of the software
 * without specific, written prior permission.  The copyright holders make
 * no representations about the suitability of this software for any purpose.
 * It is provided "as is" without express or implied warranty.
 *
 * THE COPYRIGHT HOLDERS DISCLAIM ALL WARRANTIES WITH REGARD TO THIS
 * SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS.
 * IN NO EVENT SHALL THE COPYRIGHT HOLDERS BE LIABLE FOR ANY SPECIAL,
 * INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING
 * FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT,
 * NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION
 * WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 * 
 */

#ifndef mapscripts_h
#define mapscripts_h

#include <OverlayUnidraw/scriptview.h>
#include <FrameUnidraw/framescripts.h>

class MapCovComp;
class MapDbComp;
class MapFClassComp;
class MapFeatureComp;
class MapIdrawComp;
class MapLibComp;

class MapFeatureScript : public OverlayScript {
public:
    virtual ClassId GetClassId();
    virtual boolean IsA(ClassId);
    MapFeatureScript(MapFeatureComp* = nil);

    virtual boolean Definition(ostream&);
    static int ReadFeature(istream&, void*, void*, void*, void*);
};

class MapFClassScript : public OverlaysScript {
public:
    virtual ClassId GetClassId();
    virtual boolean IsA(ClassId);
    MapFClassScript(MapFClassComp* = nil);

    virtual boolean Definition(ostream&);

    static OverlayComp* read_obj(const char* name, istream&, OverlaysComp* comps);
    static int ReadFile(istream&, void*, void*, void*, void*);
    static int ReadPath(istream&, void*, void*, void*, void*);
};

class MapCovScript : public OverlaysScript {
public:
    virtual ClassId GetClassId();
    virtual boolean IsA(ClassId);
    MapCovScript(MapCovComp* = nil);

    virtual boolean Definition(ostream&);
};

class MapLibScript : public OverlaysScript {
public:
    virtual ClassId GetClassId();
    virtual boolean IsA(ClassId);
    MapLibScript(MapLibComp* = nil);

    virtual boolean Definition(ostream&);
};

class MapDbScript : public OverlaysScript {
public:
    virtual ClassId GetClassId();
    virtual boolean IsA(ClassId);
    MapDbScript(MapDbComp* = nil);

    virtual boolean Definition(ostream&);
};

class MapIdrawScript : public FrameIdrawScript {
public:
    virtual ClassId GetClassId();
    virtual boolean IsA(ClassId);
    MapIdrawScript(MapIdrawComp* = nil);

    virtual boolean Emit(ostream&);
};

class MapFeatureRawScript : public MapFeatureScript {
public:
    virtual ClassId GetClassId();
    virtual boolean IsA(ClassId);
    MapFeatureRawScript(MapFeatureComp* = nil);

    virtual boolean Definition(ostream&);

    boolean static native() { return _native; }
    void static native(boolean v) { _native = v;}
protected:
    static boolean _native;

};

class MapFClassRawScript : public MapFClassScript {
public:
    virtual ClassId GetClassId();
    virtual boolean IsA(ClassId);
    MapFClassRawScript(MapFClassComp* = nil);

    virtual boolean Definition(ostream&);
    virtual void Update();

protected:
    OverlayScript* CreateRawMapScript(OverlayComp*);

};

#endif
